unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    CheckListBox1: TCheckListBox;
    Button1: TButton;
    Button2: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Load1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Clear1: TMenuItem;
    Settings1: TMenuItem;
    Button3: TButton;
    CheckListBox2: TCheckListBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ClearSphereWorldscp1: TMenuItem;
    LoadSphereWorld1: TMenuItem;
    About1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure LoadSphereWorld1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure ClearSphereWorldscp1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;
  cc, cc2: integer;
  ims: integer;
  createbackup: boolean = true;
  back2: boolean = true;

implementation

uses Unit2, Unit3, Unit4;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var f, fl: TextFile;
wi: string[11];
str, st : string;
maxims: integer;
begin
form1.CheckListBox1.Clear;
assignfile(f, 'spherechars.scp');
reset(f);
form2.Top := Trunc(Form1.Top + Form1.Height/2 - form2.Height/2);
form2.Left := Trunc (Form1.Left +Form1.Width/2 - form2.Width/2);
form2.Show;
Application.ProcessMessages;
form1.Button1.Enabled:=false;
form1.Button2.Enabled:=false;
form1.Button3.Enabled:=false;
form1.Clear1.Enabled:=false;
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, st);
if st <> 'false' then begin maxims:=strtoint(st);
readln(fl, st);
closefile(fl);
end;
if st='true' then
form1.CheckListBox1.Sorted:=true
else
form1.CheckListBox1.Sorted:=false;
while not eof(f) do begin
readln(f, wi, str);
if wi = '[WORLDITEM ' then begin
delete(str, length(str), 1);
ims:=ims+1;
form1.CheckListBox1.Items.Add(str);
if ims = maxims then begin
messagedlg(inttostr(ims) + ' items loaded', mtinformation, [mbok], 0);
ims:=0;
break;
end
end
end;
ims:=0;
form1.Button1.Enabled:=true;
if form1.CheckListBox1.Items.count > 0 then begin
form1.Button2.Enabled:=true;
form1.Button3.Enabled:=true;
form1.Clear1.Enabled:=true;
end;
form2.close;
closefile(f);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
form1.CheckListBox1.Clear;
form1.Button2.Enabled:=false;
form1.Button3.Enabled:=false;
form1.Clear1.Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var nonwrite: boolean;
i: integer;
stri, str, createback: string;
f, f2, fl: TextFile;
wi: string[11];
begin
if createbackup=true then begin
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
closefile(fl);
if createback='true' then
copyfile('spherechars.scp', 'spherechars.scp.bak', true);
end;
assignfile(f2, 'spherechars.scp');
reset(f2);
form2.Top := Trunc(Form1.Top + Form1.Height/2 - form2.Height/2);
form2.Left := Trunc (Form1.Left +Form1.Width/2 - form2.Width/2);
form2.Show;
Application.ProcessMessages;
form1.Button1.Enabled:=false;
form1.Button2.Enabled:=false;
form1.Button3.Enabled:=false;
form1.Clear1.Enabled:=false;
assignfile(f, 'spherechars.dat');
rewrite(f);
for i:=form1.CheckListBox1.Items.Count-1 downto 0 do begin
if form1.CheckListBox1.Checked[i] then begin
cc:=cc+1;
str:=form1.CheckListBox1.Items.Strings[i];
form1.CheckListBox1.Items.Delete(i);   break;
end
end;
str:=str + ']';
nonwrite:=false;
while not eof(f2) do begin
readln(f2, wi, stri);
if (wi='[WORLDITEM ') and (stri=str) then begin
nonwrite:=true;
readln(f2, wi, stri);
end;
if (wi='[WORLDITEM ') or (wi='[WORLDCHAR ') or (wi='[EOF]') then
nonwrite:=false;
if nonwrite=false then
writeln(f, wi, stri)

end;
closefile(f);
closefile(f2);
if not renamefile('spherechars.dat', 'spherechars.scp') then
deletefile('spherechars.scp');
renamefile('spherechars.dat', 'spherechars.scp');
if cc>0 then begin
cc:=0;
createbackup:=false;
form1.Button3.Click;
end
else begin
createbackup:=true;
form1.Button1.Enabled:=true;
if form1.CheckListBox1.Items.Count > 0 then begin
form1.Button2.Enabled:=true;
form1.Button3.Enabled:=true;
form1.Clear1.Enabled:=true;
end;
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
closefile(fl);
if createback='true' then
form1.Button1.Click;
form2.Close;
end
end;


procedure TForm1.Button4Click(Sender: TObject);
var f, fl: TextFile;
wi: string[11];
str, st : string;
maxims: integer;
begin
form1.CheckListBox2.Clear;
assignfile(f, 'sphereworld.scp');
reset(f);
form2.Top := Trunc(Form1.Top + Form1.Height/2 - form2.Height/2);
form2.Left := Trunc (Form1.Left +Form1.Width/2 - form2.Width/2);
form2.Show;
Application.ProcessMessages;
form1.Button4.Enabled:=false;
form1.Button5.Enabled:=false;
form1.Button6.Enabled:=false;
form1.ClearSphereWorldscp1.Enabled:=false;
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, st);
if st <> 'false' then begin maxims:=strtoint(st);
readln(fl, st);
closefile(fl);
end;
if st='true' then
form1.CheckListBox2.Sorted:=true
else
form1.CheckListBox2.Sorted:=false;
while not eof(f) do begin
readln(f, wi, str);
if (wi = '[WORLDITEM ') then begin
delete(str, length(str), 1);
ims:=ims+1;
form1.CheckListBox2.Items.Add(str);
if ims = maxims then begin
messagedlg(inttostr(ims) + ' items loaded', mtinformation, [mbok], 0);
ims:=0;
break;
end
end
end;
ims:=0;
form1.Button4.Enabled:=true;
if form1.CheckListBox2.Items.count > 0 then begin
form1.Button5.Enabled:=true;
form1.Button6.Enabled:=true;
form1.ClearSphereWorldscp1.Enabled:=true;
end;
form2.close;
closefile(f);
end;

procedure TForm1.Settings1Click(Sender: TObject);
begin
form3.show;
end;

procedure TForm1.Button6Click(Sender: TObject);
var nonwrite: boolean;
i: integer;
stri, str, createback: string;
f, f2, fl: TextFile;
wi: string[11];
begin
if back2=true then begin
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
closefile(fl);
if createback='true' then
copyfile('sphereworld.scp', 'sphereworld.scp.bak', true);
end;
assignfile(f2, 'sphereworld.scp');
reset(f2);
form2.Top := Trunc(Form1.Top + Form1.Height/2 - form2.Height/2);
form2.Left := Trunc (Form1.Left +Form1.Width/2 - form2.Width/2);
form2.Show;
Application.ProcessMessages;
form1.Button4.Enabled:=false;
form1.Button5.Enabled:=false;
form1.Button6.Enabled:=false;
form1.ClearSphereWorldscp1.Enabled:=false;
assignfile(f, 'sphereworld.dat');
rewrite(f);
for i:=form1.CheckListBox2.Items.Count-1 downto 0 do begin
if form1.CheckListBox2.Checked[i] then begin
cc2:=cc2+1;
str:=form1.CheckListBox2.Items.Strings[i];
form1.CheckListBox2.Items.Delete(i);   break;
end
end;
str:=str + ']';
nonwrite:=false;
while not eof(f2) do begin
readln(f2, wi, stri);
if (wi='[WORLDITEM ') and (stri=str) then begin
nonwrite:=true;
readln(f2, wi, stri);
end;
if (wi='[WORLDITEM ') or (wi='[WORLDCHAR ') or (wi='[EOF]') then
nonwrite:=false;
if nonwrite=false then
writeln(f, wi, stri)

end;
closefile(f);
closefile(f2);
if not renamefile('sphereworld.dat', 'sphereworld.scp') then
deletefile('sphereworld.scp');
renamefile('sphereworld.dat', 'sphereworld.scp');
if cc2>0 then begin
back2:=false;
cc2:=0;
form1.Button6.Click;
end
else begin
back2:=true;
form1.Button4.Enabled:=true;
if form1.CheckListBox2.Items.Count > 0 then begin
form1.Button5.Enabled:=true;
form1.Button6.Enabled:=true;
form1.ClearSphereWorldscp1.Enabled:=true;
end;
assignfile(fl, 'settings.dat');
reset(fl);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
readln(fl, createback);
closefile(fl);
if createback='true' then
form1.Button4.Click;
form2.Close;
end
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
form1.CheckListBox2.Clear;
form1.Button5.Enabled:=false;
form1.Button6.Enabled:=false;
form1.ClearSphereWorldscp1.Enabled:=false;
end;

procedure TForm1.Load1Click(Sender: TObject);
begin
form1.Button1.Click;
end;

procedure TForm1.LoadSphereWorld1Click(Sender: TObject);
begin
form1.Button4.click;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
form1.Close;
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
form1.Button2.Click;
end;

procedure TForm1.ClearSphereWorldscp1Click(Sender: TObject);
begin
form1.Button5.click;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
form4.Top := Trunc(Form1.Top + Form1.Height/2 - form4.Height/2);
form4.Left := Trunc (Form1.Left +Form1.Width/2 - form4.Width/2);
form4.Show;
end;

end.
